#include <SPI.h>           // Ethernet shield
#include <Ethernet.h>      // Ethernet shield
#include <PubSubClient.h>  // MQTT 
#include <Servo.h>
#include <dht.h>
#include <OneWire.h>
#include <DallasTemperature.h> 
Servo servo;

byte mac[]    = { 0xC1, 0x7C, 0x38, 0x41, 0x89, 0x15 };
byte server[] = { 192, 168, 25, 15 }; //IP Брокера
byte ip[]     = { 192, 168, 25, 88 }; //IP Клиента (Arduino)

////////////////////////////////////////////////////////////////////////////
void callback(char* topic, byte* payload, unsigned int length) {
    payload[length] = '\0';
   // Serial.print(topic);
   // Serial.print("=");
    String strTopic = String(topic);
    String strPayload = String((char*)payload);
   // Serial.println(strPayload);
    callback_iobroker(strTopic, strPayload);
}

EthernetClient ethClient;
PubSubClient client(server, 1883, callback, ethClient);
#define id_connect "myhome-kitchen"
#define Prefix_subscribe "myhome/Kitchen/"

///////////////Объявляем порты ввода-вывода
#define ServoPin 3 //Порт к которому подключен сервопривод

const int start_DI_pin []= {2, 4, 5}; // Порты Ввода
int n_DI_pin = sizeof(start_DI_pin) / sizeof(start_DI_pin[0])-1; //Вычисляем длинну массива

const int start_DO_pin []= {6, 7}; //Порты Вывода
int n_DO_pin = sizeof(start_DO_pin) / sizeof(start_DO_pin[0])-1; //Вычисляем длинну массива

int DI[]     = {0, 0, 0};
int old_DI[] = {0, 0};

///////////////////////////Переменные для работы с освещением//////////////////////////////////////
int ServoAngle = 100; //Угол сервопривода при включении
int flag = 0;
int flag2 = 0;
int pause = 0;

//------------------------------------------- Sensors -------------------------------------------//
const int MQ7_Pin = A0; // Куда подключили MQ7
//int MQ7Value = 0; 
int MQ7Value = analogRead(MQ7_Pin); 
 
 
 const int foto_Pin = A1;    // устанавливаем входную ногу для Фоторезистора
//unsigned int fotoValue = 0;  // цифровое значение фоторезистора
 unsigned int fotoValue = analogRead(foto_Pin);

#define ONE_WIRE_BUS 8
//#define TEMPERATURE_PRECISION 9
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature DS_sensors(&oneWire);
                                 //   28 80 E9 3A 04 00 00 10
DeviceAddress addr_T1 = { 0x28, 0x80, 0xE9, 0x3A, 0x4, 0x0, 0x0, 0x10 };

float T1=0;

//dht DHT;
//#define DHT22_PIN 9
//float Hout = 0;
//float Tout = 0;

////////////////////////////////////////////////////////////////////////////
//void callback(char* topic, byte* payload, unsigned int length) {
//    payload[length] = '\0';
   // Serial.print(topic);
   // Serial.print("=");
//    String strTopic = String(topic);
//    String strPayload = String((char*)payload);
   // Serial.println(strPayload);
//    callback_iobroker(strTopic, strPayload);
//}
////////////////////////////////////////////////////////////////////////////
void setup() {
  Serial.begin(57600);
  Serial.println("start");
  
   Serial.print("Locating devices...");
  DS_sensors.begin();
  Serial.print("Found ");
  Serial.print(DS_sensors.getDeviceCount(), DEC);
  Serial.println(" devices.");

  // report parasite power requirements
  Serial.print("Parasite power is: "); 
  if (DS_sensors.isParasitePowerMode()) Serial.println("ON");
  else Serial.println("OFF");
  
    //Объявляем порты Digital inputs/outputs
  for(int i=0 ;i<=n_DI_pin; i++) { pinMode (start_DI_pin [i], INPUT); }
  digitalWrite(5, HIGH); //Окно
  digitalWrite(4, HIGH); //Объемник
  for(int i=0 ;i<=n_DO_pin; i++) { pinMode (start_DO_pin [i], OUTPUT); }

  Ethernet.begin(mac, ip);
  if (client.connect(id_connect)) {
    getSensors();
    control();
    client.publish("myhome/Kitchen/Change_Counter", "0");
    client.publish("myhome/Kitchen/Temp_room", "0");
    client.publish("myhome/Kitchen/Humidity_room", "0");
    client.publish("myhome/Kitchen/Temp_radiator", "0");
    client.publish("myhome/Kitchen/Temp_in", "0");
    client.publish("myhome/Kitchen/Lux", "0");
    client.publish("myhome/Kitchen/Servo", "0");
    client.publish("myhome/Kitchen/MQ7", "0");
    
    client.subscribe("myhome/Kitchen/#");
  }
}
/////////////////////////////////////////////////////////////////////////
void loop() {
  client.loop();
  control();
  getSensors();
      if (!client.connected()) {
        if (client.connect(id_connect)) {
      control();
      getSensors();
      client.subscribe("myhome/Kitchen/#");
        }
    }
}
